﻿using System.Linq.Expressions;

namespace DynamicExpressionEditorExample.Expressions
{
	public class ParameterBinderVisitor : ExpressionVisitor
	{
		private readonly ParameterExpression parameter;
		private readonly object parameterValue;

		public ParameterBinderVisitor(ParameterExpression parameter, object parameterValue)
		{
			this.parameter = parameter;
			this.parameterValue = parameterValue;
		}

		protected override Expression VisitParameter(ParameterExpression node)
		{
			if (this.parameter == node)
			{
				return Expression.Constant(this.parameterValue);
			}

			return base.VisitParameter(node);
		}

		protected override Expression VisitLambda<T>(Expression<T> node)
		{
			return node.Update(this.Visit(node.Body), node.Parameters);
		}
	}
}